Attribute VB_Name = "Module_Recap"
Sub MakeRecap()
ActiveWindow.View = xlNormalView 'On se met en affichage normal car l'affichage mode mise en page genere des erreur "aleatoire"
Dim start as single
Start = timer
''' En premier lieu on trie les feuilles par ordre alhabetique
For i = 1 To Sheets.Count
	For j = i + 1 To Sheets.Count
		If UCase(Sheets(i).Name) > UCase(Sheets(j).Name) Then Sheets(j).Move before:=Sheets(i)
	Next j
Next i
'''
Dim Feuille As Long, Ligne As Long, ColonneMaitre As Long, LigneMaitre As Long, LigneImport2 As Long
Ligne = 2
Sheets(" Recap").Select
Cells.Select
Selection.Clear 'On purge le Recap
Cells(1, 1).Value = "SN"
LigneMaitre = Sheets(2).Range("A65536").End(xlUp).Row
ColonneMaitre = Sheets(2).Range("IV1").End(xlToLeft).Column
        For i = 2 To ColonneMaitre 'Bouclage sur tous les entete de colonne on commence à 2 car on ne recupere pas la premiere colonne (Date)
            Cells(1, i).Value = Sheets(2).Cells(1, i).Value
        Next
For Feuille = 2 To Worksheets.Count 'on commence a boucler sur toutes les pages du classeur
	LigneImport2 = Sheets(Feuille).Range("A65536").End(xlUp).Row
    ''' Controle et ajout le cas echeant d'une bouton de retour vers le recap
	If Sheets(Feuille).Shapes.Count = 0 Then 'Si la feuille ne contient aucun bouton alors on en genere un
		Dim PosG As Integer, PosH As Integer, Hauteur As Integer, Longueur As Integer
		With Sheets(Feuille).Cells(1, 1)
			PosG = .Left
			PosH = .Top
			Hauteur = .Height / 2
			Longueur = .Width
		End With
		With Sheets(Feuille).Buttons
			.Add(PosG, PosH, Longueur, Hauteur).Select
			.OnAction = "GoToRecap"
			.Caption = "Recap."
		End With
	End If
	'''
    With Sheets(Feuille)
		if ColonneMaitre <> .Range("IV1").End(xlToLeft).Column then
		'''Alors on ajoute / suprime les colonne manquante ou en trop
		End if
        For i = 1 To ColonneMaitre
			If Not Feuille = 2 Then 'Copie des entete et pied de page de la feuille 2 vers toutes les autre.
				.Cells(1, i).Value = Sheets(2).Cells(1, i).Value
				.Cells(LigneImport2, i).Value = Sheets(2).Cells(LigneMaitre, i).Formula
			End If
        Next
		Dim AvantDerniere As Long
		AvantDerniere = .Range(Search("cnd", Feuille) & LigneImport2 - 1).End(xlUp).Row
		.Range(Search("utilisation", Feuille) & LigneImport2).FormulaR1C1 = "=SUM(R[-" & LigneImport2 - AvantDerniere & "]C:R[-1]C)"
        .ListObjects(1).Name = .Name 'Renomage des tables pour une navigation plus aisé
		''' Remplissage du recap
        ActiveSheet.Hyperlinks.Add Anchor:=Cells(Ligne, 1), Address:="", SubAddress:="'" & .Name & "'!A1", TextToDisplay:=.Name
        For i = 2 To ColonneMaitre	
            Cells(Ligne, i).Value = .Cells(LigneImport2, i).Value
        Next
		''' Mise en Place d'un preview du type de piece
		If Len(Dir(ThisWorkbook.Path & "\0 - Zone Controle & Image\" & Cells(Ligne, 2).Value & ".png")) > 0 Then
			With Range("B" & Ligne)
				.ClearComments
				.AddComment
				.Comment.Shape.Fill.UserPicture ThisWorkbook.Path & "\0 - Zone Controle & Image\" & .Value & ".png"
				.Comment.Shape.Width = 765
				.Comment.Shape.Height = 498
			End With
		End if
    End With
    Ligne = Ligne + 1
Next
'Création du tableau
ActiveSheet.ListObjects.Add(xlSrcRange, Range(Cells(1, 1), Cells(Ligne - 1, ColonneMaitre)), , xlYes).Name = "TabRecap"
ActiveSheet.ListObjects("TabRecap").TableStyle = "TableStyleLight9"
'''Mise en place d'une regle d'alerte sur le nombre d'utilisation d'un outillage
    Range("TabRecap[Nombre" & Chr(10) & "d''Utilisation]").Select
    Selection.FormatConditions.Add Type:=xlCellValue, Operator:=xlGreaterEqual, Formula1:="=10" '<------------------------Seuil d'alerte pour CND
    Selection.FormatConditions(Selection.FormatConditions.Count).SetFirstPriority
    With Selection.FormatConditions(1).Interior
        .PatternColorIndex = xlAutomatic
        .Color = 255
        .TintAndShade = 0
    End With
    Selection.FormatConditions(1).StopIfTrue = False
'''
ActiveSheet.Range("A1").Select
Application.StatusBar = "Recap mis à jour en " & timer-start & " secondes" 
End Sub
Function Search(Valeur As String, Feuille As Long) As String 'Fonctin utile au comptage du nombre d'utilisation
	Dim Resultat As Range
	Set Resultat = Sheets(Feuille).Rows(1).Cells.Find(what:="*" & Valeur, LookAt:=xlWhole)
	If Not Resultat Is Nothing Then
		Search = Split(Resultat.Address, "$")(1)
	Else
		Search = 0
	End If
End Function
Sub GoToRecap()
Sheets(1).Select
End Sub

''' Fonction indépendante permetant de suprimer tout les boutons
Sub DeleteAllShapes()
Dim Shp As Shape
Dim Feuille As Long
For Feuille = 2 To Worksheets.Count
    For Each Shp In Sheets(Feuille).Shapes
        Shp.Delete
    Next
Next
End Sub